# jsCommunicator
Communicator client for javascript

### Install

`npm install jscommunicator --save`

### Usage

index.js

```
jscomm = require('jscommunicator')

client = new jscomm.CommunicatorClient(host, config, appName)

module.exports({
  client: client
})

```
`host` eg. abc-access123.practodev.com

`config` eg. { communicator: { communicatorQueueUri: 'beanstalk://localhost/dev-', signingKey: 'xxxx' } }

`appName` eg. accounts

#### Get instance for the type of mail or sms

```
index = require("./index.js")
obj = index.client.getInstance('smsGenericPromotional')
```

#### Sending sms/email

```
obj.sendSms(params)
obj.sendMail(params)
```

#### Fetching sms/email info [GET request]
```
obj.getMessagesByReferenceId(2, '["FIT_RAY_SHARE_SMS"]', (err, response)=>{
  if(err){
    console.log(err);
  }
  else{
    console.log(response)}
  })
```

### To contribute in jsCommunicator

Clone the repo

Finally build using `npm run build`

Update package in npm using `npm publish`

##### Note: Please don't push the lib version in git repository. Only the source code.

