"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var base = require('./base');
var types = require('./types');

var MailGenericTransactional = function (_base$Base) {
  _inherits(MailGenericTransactional, _base$Base);

  function MailGenericTransactional(host, config, appName) {
    _classCallCheck(this, MailGenericTransactional);

    return _possibleConstructorReturn(this, (MailGenericTransactional.__proto__ || Object.getPrototypeOf(MailGenericTransactional)).call(this, host, config, appName));
  }

  _createClass(MailGenericTransactional, [{
    key: 'sendMail',
    value: function sendMail(fromName, fromMail, subject, body, emailType, files, to, hash, referenceId, referenceType) {
      var toName = arguments.length > 10 && arguments[10] !== undefined ? arguments[10] : "";
      var cc = arguments.length > 11 && arguments[11] !== undefined ? arguments[11] : "";
      var bcc = arguments.length > 12 && arguments[12] !== undefined ? arguments[12] : "";
      var plaintext = arguments.length > 13 && arguments[13] !== undefined ? arguments[13] : "";
      var replyTo = arguments.length > 14 && arguments[14] !== undefined ? arguments[14] : null;
      var expiryTime = arguments.length > 15 && arguments[15] !== undefined ? arguments[15] : null;
      var createdBy = arguments.length > 16 && arguments[16] !== undefined ? arguments[16] : null;

      this.validateMailType(emailType.toUpperCase());
      var job = new types.GenericTransactionalMail();
      job.from_name = fromName;
      job.from_address = fromMail;
      job.to_name = toName;
      job.to_address = to;
      job.expiry_time = expiryTime;
      job.subject = subject;
      job.body = body;
      job.plaintext = plaintext;
      job.reference_id = referenceId;
      job.reference_type = referenceType;
      job.app_name = this.appName;
      job.created_by = createdBy;
      job.email_type = emailType.toUpperCase();
      job.reply_to = replyTo;
      job.hash = hash;
      job.mail_type = 'generic_transactional';

      if (referenceId !== parseInt(referenceId, 10)) {
        throw "referenceId should be integer";
      }
      if (typeof cc == 'string' && cc.length > 0) {
        job.cc = [cc];
      } else {
        job.cc = cc;
      }
      if (typeof bcc == 'string' && bcc.length > 0) {
        job.bcc = [bcc];
      } else {
        job.bcc = bcc;
      }

      var attachments = [];
      if (files) {
        for (var i = 0; i < files.length; i++) {
          var att = new types.Attachment();
          att.name = files[i];
          att.location = files[files[i]];
          attachments.push(att);
        }
      }
      job.attachments = attachments;
      this.send(job, this.queueNames.sendGenericTransactionalMailQueue, 0);
    }
  }, {
    key: 'getMailCountByType',
    value: function getMailCountByType(mailType, startDate, endDate, deliveryStatus, callback) {
      var data = {};
      data.start_date = startDate;
      data.end_date = endDate;
      data.mail_type = mailType;
      data.delivery_status = deliveryStatus;
      var response = this.get('/generictransactionalmail/get_mail_count_for_type', data, function (err, response) {
        if (err) {
          callback(err);
        } else {
          callback(null, response);
        }
      });
    }
  }, {
    key: 'validateMailType',
    value: function validateMailType(type) {
      var allowedTypes = ['FABRIC_ROI_REPORT', 'FABRIC_RENEWAL_ALERT', 'MERGE_ACCOUNTS_NOTIFICATION', 'MERGE_FAILED', 'VN_DETAILS', 'ALERT_BAD_HEALTH', 'FABRIC_DQS_REPORT', 'SURVEY_VERIFICATION_EMAIL', 'FIT_GENERIC_MAIL', 'FIT_EDITOR_FEEDBACK_MAIL', 'CONSULT_GENERIC_MAIL', 'REACH_TOS_MAIL', 'REACH_QUALITY_REMINDER', 'QIKWELL_APPOINTMENT_REMINDER_MAIL', 'FEEDBACK_DAILY_HEALTH_EMAIL', 'FEEDBACK_SURVEY_EMAIL', 'TAB_BIAS_DAILY_REPORT', 'TAB_BIAS_DETECTION_EMAIL', 'SCOUT_HOURLY_MAIL', 'PHARMA_MAIL', 'RAY_REPORT_APPOINTMENTS', 'RAY_REPORT_APPOINTMENTS_SUMMARY', 'RAY_REPORT_DAILY_SUMMARY', 'RAY_REPORT_EXPENSE', 'RAY_REPORT_EXPENSE_SUMMARY', 'RAY_REPORT_INVOICE', 'RAY_REPORT_INVOICE_SUMMARY', 'RAY_REPORT_PATIENTS', 'RAY_REPORT_PATIENTS_SUMMARY', 'RAY_REPORT_PAYMENT', 'RAY_REPORT_PAYMENTS_SUMMARY', 'RAY_REPORT_PAYMENT_DETAILS_SUMMARY', 'RAY_REPORT_TREATMENTS', 'RAY_REPORT_TREATMENTS_SUMMARY', 'DOCTOR_NO_SHOW', 'REACH_DAILY_ROI_EMAIL', 'FABRIC_BLUEBOOK_MAIL', 'STORE_SELF_RENEWAL', 'STORE_REFERRAL_EMAILS', 'STORE_KEY_ACCOUNT_GROUP', 'DX_ORDER_CREATED_LAB', 'DX_ORDER_CREATED_CUSTOMER', 'DX_ORDER_CREATED_OPS', 'DX_ORDER_RESCHEDULE_LAB', 'DX_REPORT_SHARED', 'DX_ORDER_CANCELLED_EDIT_LAB', 'DX_ORDER_CANCELLED_EDIT_CUSTOMER', 'DX_ORDER_CANCELLED_EDIT_OPS', 'DX_ORDER_CANCELLED_LAB', 'DX_ORDER_CANCELLED_CUSTOMER', 'DX_ORDER_CANCELLED_OPS', 'DX_ONBOARDING_DOS_GENERATION', 'DX_ONBOARDING_DOS_REVIEW', 'SOS'];

      if (allowedTypes.indexOf(type) < 0) {
        throw "Invalid mail type";
      }
    }
  }]);

  return MailGenericTransactional;
}(base.Base);

module.exports = {
  MailGenericTransactional: MailGenericTransactional
};