"use strict";

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DateTime = require('node-datetime');

var GenericTransactionalSms = function GenericTransactionalSms() {
    _classCallCheck(this, GenericTransactionalSms);

    this.id = null;
    this.reference_id = null;
    this.reference_type = null;
    this.name = null;
    this.mobile = null;
    this.message_text = null;
    this.message_type = null;
    this.delivery_time = null;
    this.status = null;
    this.failure_reason = null;
    this.attempt = null;
    this.operator = null;
    this.operator_reply = null;
    this.operator_code = null;
    this.created_by = null;
    this.created_on = DateTime.create().format('Y-M-d H:M:S');
    this.modified_by = null;
    this.modified_on = null;
    this.app_name = null;
    this.currency = null;
    this.cost = null;
    this.expiry_time = null;
    this.notes = null;
    this.sender_id = null;
};

var GenericTransactionalMail = function GenericTransactionalMail() {
    _classCallCheck(this, GenericTransactionalMail);

    this.generic_transactional_mail_id = null;
    this.from_name = null;
    this.from_address = null;
    this.to_address = null;
    this.cc = null;
    this.bcc = null;
    this.subject = null;
    this.body = null;
    this.date = parseInt((+new Date() / 1000).toString());
    this.attachments = null;
    this.email_type = null;
    this.created_by = null;
    this.created_on = DateTime.create().format('Y-M-d H:M:S');
    this.modified_by = null;
    this.modified_on = null;
    this.delivery_status = null;
    this.email_provider = null;
    this.message_id = null;
    this.smtp_reply = null;
    this.open_time = null;
    this.open_bounce_data = null;
    this.unsubscribe_data = null;
    this.spam_data = null;
    this.hash = null;
    this.plaintext = null;
    this.app_name = null;
    this.to_name = null;
    this.mail_type = null;
    this.attempt = null;
    this.reply_to = null;
    this.reference_id = null;
    this.reference_type = null;
    this.expiry_time = null;
};

var GenericPromotionalSms = function GenericPromotionalSms() {
    _classCallCheck(this, GenericPromotionalSms);

    this.id = null;
    this.reference_id = null;
    this.reference_type = null;
    this.name = null;
    this.mobile = null;
    this.message_text = null;
    this.message_type = null;
    this.delivery_time = null;
    this.status = null;
    this.failure_reason = null;
    this.attempt = null;
    this.operator = null;
    this.operator_reply = null;
    this.operator_code = null;
    this.created_by = null;
    this.created_on = DateTime.create().format('Y-M-d H:M:S');
    this.modified_by = null;
    this.modified_on = null;
    this.initiated_at = null;
    this.app_name = null;
    this.currency = null;
    this.cost = null;
    this.expiry_time = null;
    this.notes = null;
    this.sender_id = null;
};

var GenericPromotionalMail = function GenericPromotionalMail() {
    _classCallCheck(this, GenericPromotionalMail);

    this.generic_promotional_mail_id = null;
    this.from_name = null;
    this.from_address = null;
    this.to_address = null;
    this.cc = null;
    this.bcc = null;
    this.subject = null;
    this.body = null;
    this.date = int(time.time());
    this.attachments = null;
    this.email_type = null;
    this.created_by = null;
    this.created_at = DateTime.create().format('Y-M-d H:M:S');
    this.modified_by = null;
    this.modified_on = null;
    this.delivery_status = null;
    this.email_provider = null;
    this.message_id = null;
    this.smtp_reply = null;
    this.open_time = null;
    this.open_bounce_data = null;
    this.unsubscribe_data = null;
    this.spam_data = null;
    this.hash = null;
    this.plaintext = null;
    this.app_name = null;
    this.to_name = null;
    this.mail_type = null;
    this.attempt = null;
    this.reply_to = null;
    this.reference_id = null;
    this.reference_type = null;
    this.expiry_time = null;
};

var Otp = function Otp() {
    _classCallCheck(this, Otp);

    this.transaction_id = null;
    this.transaction_type = null;
    this.mobile = null;
    this.otp = null;
    this.initiated_at = DateTime.create().format('Y-M-d H:M:S');
    this.app_name = null;
    this.expiry_time = null;
    this.max_retry = null;
};

var OtpSms = function OtpSms() {
    _classCallCheck(this, OtpSms);

    this.id = null;
    this.reference_id = null;
    this.reference_type = null;
    this.name = null;
    this.mobile = null;
    this.template = null;
    this.otp = null;
    this.message_type = null;
    this.delivery_time = null;
    this.status = null;
    this.failure_reason = null;
    this.attempt = null;
    this.operator = null;
    this.operator_reply = null;
    this.operator_code = null;
    this.created_by = null;
    this.created_on = DateTime.create().format('Y-M-d H:M:S');
    this.modified_by = null;
    this.modified_on = null;
    this.app_name = null;
    this.currency = null;
    this.cost = null;
    this.expiry_time = null;
    this.notes = null;
    this.sender_id = null;
};

var OtpCall = function OtpCall() {
    _classCallCheck(this, OtpCall);

    this.id = null;
    this.reference_id = null;
    this.reference_type = null;
    this.name = null;
    this.mobile = null;
    this.message_text = null;
    this.otp = null;
    this.message_type = null;
    this.delivery_time = null;
    this.status = null;
    this.failure_reason = null;
    this.attempt = null;
    this.operator = null;
    this.operator_reply = null;
    this.operator_code = null;
    this.created_by = null;
    this.created_on = null;
    this.modified_by = null;
    this.modified_on = DateTime.create().format('Y-M-d H:M:S');
    this.app_name = null;
    this.currency = null;
    this.cost = null;
    this.expiry_time = null;
    this.notes = null;
};

var Attachment = function Attachment() {
    var vals = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, Attachment);

    this.name = vals.name;
    this.location = vals.location;
};

var PushData = function PushData() {
    _classCallCheck(this, PushData);

    this.title = '';
    this.body = '';
    this.sound = '';
    this.body_loc_args = '';
    this.body_loc_key = '';
    this.title_loc_key = '';
    this.title_loc_args = '';
    this.custom = {};
};

var AndroidPushData = function (_PushData) {
    _inherits(AndroidPushData, _PushData);

    function AndroidPushData() {
        _classCallCheck(this, AndroidPushData);

        var _this = _possibleConstructorReturn(this, (AndroidPushData.__proto__ || Object.getPrototypeOf(AndroidPushData)).call(this));

        _this.icon = '';
        return _this;
    }

    return AndroidPushData;
}(PushData);

var IosPushData = function (_PushData2) {
    _inherits(IosPushData, _PushData2);

    function IosPushData() {
        _classCallCheck(this, IosPushData);

        var _this2 = _possibleConstructorReturn(this, (IosPushData.__proto__ || Object.getPrototypeOf(IosPushData)).call(this));

        _this2.badge = '';
        return _this2;
    }

    return IosPushData;
}(PushData);

var PushObj = function PushObj() {
    _classCallCheck(this, PushObj);

    this.app_name = '';
    this.service = '';
    this.reference_id = '';
    this.reference_type = '';
    this.data = {};
    this.app_version = {};
    this.is_silent = undefined;
    this.last_active = {};
    this.account_id = '';
    this.is_content_available = undefined;
    this.device_id = '';
    this.push_type = '';
};

var IosPushObj = function (_PushObj) {
    _inherits(IosPushObj, _PushObj);

    function IosPushObj() {
        _classCallCheck(this, IosPushObj);

        var _this3 = _possibleConstructorReturn(this, (IosPushObj.__proto__ || Object.getPrototypeOf(IosPushObj)).call(this));

        _this3.data = new IosPushData();
        _this3.is_silent = false;
        _this3.app_name = 'ios';
        return _this3;
    }

    return IosPushObj;
}(PushObj);

var AndroidPushObj = function (_PushObj2) {
    _inherits(AndroidPushObj, _PushObj2);

    function AndroidPushObj() {
        _classCallCheck(this, AndroidPushObj);

        var _this4 = _possibleConstructorReturn(this, (AndroidPushObj.__proto__ || Object.getPrototypeOf(AndroidPushObj)).call(this));

        _this4.data = new AndroidPushData();
        _this4.is_silent = false;
        _this4.app_name = 'android';
        return _this4;
    }

    return AndroidPushObj;
}(PushObj);

var PatientPromoAndroidPushObj = function (_AndroidPushObj) {
    _inherits(PatientPromoAndroidPushObj, _AndroidPushObj);

    function PatientPromoAndroidPushObj() {
        _classCallCheck(this, PatientPromoAndroidPushObj);

        return _possibleConstructorReturn(this, (PatientPromoAndroidPushObj.__proto__ || Object.getPrototypeOf(PatientPromoAndroidPushObj)).call(this));
    }

    return PatientPromoAndroidPushObj;
}(AndroidPushObj);

var PatientTransAndroidPushObj = function (_AndroidPushObj2) {
    _inherits(PatientTransAndroidPushObj, _AndroidPushObj2);

    function PatientTransAndroidPushObj() {
        _classCallCheck(this, PatientTransAndroidPushObj);

        return _possibleConstructorReturn(this, (PatientTransAndroidPushObj.__proto__ || Object.getPrototypeOf(PatientTransAndroidPushObj)).call(this));
    }

    return PatientTransAndroidPushObj;
}(AndroidPushObj);

var PatientPromoIosPushObj = function (_IosPushObj) {
    _inherits(PatientPromoIosPushObj, _IosPushObj);

    function PatientPromoIosPushObj() {
        _classCallCheck(this, PatientPromoIosPushObj);

        return _possibleConstructorReturn(this, (PatientPromoIosPushObj.__proto__ || Object.getPrototypeOf(PatientPromoIosPushObj)).call(this));
    }

    return PatientPromoIosPushObj;
}(IosPushObj);

var PatientTransIosPushObj = function (_IosPushObj2) {
    _inherits(PatientTransIosPushObj, _IosPushObj2);

    function PatientTransIosPushObj() {
        _classCallCheck(this, PatientTransIosPushObj);

        return _possibleConstructorReturn(this, (PatientTransIosPushObj.__proto__ || Object.getPrototypeOf(PatientTransIosPushObj)).call(this));
    }

    return PatientTransIosPushObj;
}(IosPushObj);

var PushDataTypes = function PushDataTypes() {
    _classCallCheck(this, PushDataTypes);

    this.types = {
        'app_name': "string",
        'service': "string",
        'reference_id': "string",
        'reference_type': "string",
        'app_version': "object",
        'is_silent': "boolean",
        'last_active': "object",
        'account_id': "string",
        'is_content_available': "boolean",
        'device_id': "string",
        'data': "object"
    };
};

module.exports = {
    GenericTransactionalSms: GenericTransactionalSms,
    GenericTransactionalMail: GenericTransactionalMail,
    GenericPromotionalSms: GenericPromotionalSms,
    GenericPromotionalMail: GenericPromotionalMail,
    Otp: Otp,
    OtpCall: OtpCall,
    OtpSms: OtpSms,
    Attachment: Attachment,
    PatientPromoAndroidPushObj: PatientPromoAndroidPushObj,
    PatientTransAndroidPushObj: PatientTransAndroidPushObj,
    PatientPromoIosPushObj: PatientPromoIosPushObj,
    PatientTransIosPushObj: PatientTransIosPushObj,
    PushDataTypes: PushDataTypes
};