"use strict"

let basePush =  require('./basePush');
let types = require('./types');
let exceptions = require('./exceptions');
let queueNames = require('./queueNames');

let BasePush = basePush.BasePush;
let PatientPromoIosPushObj = types.PatientPromoIosPushObj;
let PushValidationException = exceptions.PushValidationException;


class PatientPromoIosPush extends BasePush {
    constructor(host, config, appName) {
        super(host, config, appName);
        this.comm_app_name = 'fabric-ios';
        this.pushNotification = new PatientPromoIosPushObj();
        this.pushNotification.service = appName;
        this.queue_name = queueNames.sendPatientPromoPushQueue;
    }

    validateFilters(inputDict) {
        this.validatePushRelationKeys(inputDict);
    }

    validatePushType(pushType) {
        let allowed_types = []
        if (allowed_types.indexOf(pushType) == -1)
            throw new PushValidationException("Invalid push notification type");
    }
}

module.exports = {
    PatientPromoIosPush: PatientPromoIosPush
}
